
package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class MouseListener implements Runnable {

	protected Control Ctrl;

	public MouseListener(Control btn, PApplet pa) {
		this.Ctrl = btn;
		this.papplet = pa;
	}

	final boolean PRESSED = true;
	final boolean NotPRESSED = false;
	final boolean NEWEVENT = true;
	final boolean NoNEWEVENT = false;

	PApplet papplet;

	// event listener checker
	public void run() {
		long t0 = System.nanoTime();
		if (Ctrl.Visible && Ctrl.Enabled) {

			if (papplet.mouseX > Ctrl.Bounds.X0 && papplet.mouseX < Ctrl.Bounds.X && papplet.mouseY > Ctrl.Bounds.Y0
					&& papplet.mouseY < Ctrl.Bounds.Y) {

				if (papplet.mousePressed) { // PRESS
					// Ctrl.press(papplet.mouseX, papplet.mouseY);

					if (!Ctrl.pPressed) {
						Ctrl.pPressed = true;
						// Ctrl.pressed(PRESSED, NEWEVENT);
					} else {
						// Ctrl.pressed(PRESSED, NoNEWEVENT);
					}
				} else if (!papplet.mousePressed && Ctrl.pPressed) { // RELEASE
					// Ctrl.release(papplet.mouseX, papplet.mouseY);

					// Ctrl.pressed(NotPRESSED, NEWEVENT);
					Ctrl.pPressed = false;
				} else {
					if (!Ctrl.pHovered) { // ENTER
						// Ctrl.enter(papplet.mouseX, papplet.mouseY);
						Ctrl.pHovered = true;
						// Ctrl.hover(true, NEWEVENT);
					}
				}
			} else {
				if (Ctrl.pHovered) { // EXIT
					// Ctrl.exit(papplet.mouseX, papplet.mouseY);
					Ctrl.pHovered = false;
					// Ctrl.hover(false, NEWEVENT);
				}
			}
		}
		// println(System.nanoTime()-t0);
	}
}