
package pGUI.core;

import processing.core.*;
import processing.event.*;

import pGUI.classes.*;

public class Label extends Control {

	public Label(PApplet pa) {
		super(pa);
		BorderWidth = 0;
		VisualBackgroundColor = 0;
	}

	@Override
	protected void render() {

		pg = papplet.createGraphics(Width, Height);
		pg.beginDraw();

		drawDefaultBackground();
		drawDefaultText();

		pg.endDraw();
	}

	@Override
	protected void autosize() {
		pg = papplet.createGraphics(1, 1);
		pg.beginDraw();
		pg.textSize(FontSize);
		Width = (int) PApplet.constrain(pg.textWidth(Text) + 1, MinWidth, MaxWidth) + PaddingLeft + PaddingRight;
		Height = PApplet.constrain(FontSize, MinHeight, MaxHeight) + PaddingTop + PaddingBottom;
	}
}